function varargout = analyza(varargin)
% ANALYZA M-file for analyza.fig
%      ANALYZA, by itself, creates a new ANALYZA or raises the existing
%      singleton*.
%
%      H = ANALYZA returns the handle to a new ANALYZA or the handle to
%      the existing singleton*.
%
%      ANALYZA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ANALYZA.M with the given input arguments.
%
%      ANALYZA('Property','Value',...) creates a new ANALYZA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before analyza_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to analyza_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help analyza

% Last Modified by GUIDE v2.5 20-Apr-2011 09:00:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @analyza_OpeningFcn, ...
                   'gui_OutputFcn',  @analyza_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before analyza is made visible.
function analyza_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to analyza (see VARARGIN)

% Choose default command line output for analyza
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes analyza wait for user response (see UIRESUME)
% uiwait(handles.figure2);

global map01 film film2 obraz_fluoro obraz_skia cislo_fluoro cislo_skia obraz_rozdil1 obraz_rozdil2 

% prava velikosti okna
pom2 = get(0,'ScreenSize');
pom3 = get(handles.figure2,'Position');
pom3(1) = (pom2(3)-pom3(3))/2;
pom3(2) = (pom2(4)-pom3(4))/2;
set(handles.figure2,'Position', pom3);
pom1=get(handles.figure2,'OuterPosition');
set(handles.figure2,'OuterPosition',[pom1(1) pom1(2) 882 652]);
clear pom1 pom2 pom3

% Naten a zobrazen obrzk znamnek odtn a ipek
axes(handles.cervene);
image(imread('cervene.png'));
axis off
axes(handles.modre);
image(imread('modre.png'));
axis off
axes(handles.cervena);
image(imread('cervena.png'));
axis off
axes(handles.modra);
image(imread('modra.png'));
axis off

% Inicializace barevn mapy
map01=zeros(256,3);
a=linspace(0,1,256);
for i=1:256;
    map01(i,:)=a(i);
end;

% Naten zskanch obraz a akv. a rek. parametr
load pamet_info
load film
load film2

% Peveden akv. a rek. parametr do samostatnch globlnch promnnch
poradovecislo=pamet_info{1};
rychlostrotace=pamet_info{2};
kteryfiltr=pamet_info{3};
pocetprojekci=pamet_info{4};
pocetsektoru=pamet_info{5};
rychlostzasunu=pamet_info{6};
expozice=pamet_info{7};
fr_prezentace=pocetsektoru*rychlostrotace/360;

% Zobrazen akv. a rek. parametr
set(handles.text_param1x,'String',[num2str(rychlostrotace) ' / s']);
switch kteryfiltr
    case 1; set(handles.text_param2x,'String','Ram-Lak');
    case 2; set(handles.text_param2x,'String','Shepp-Logan');
    case 3; set(handles.text_param2x,'String','Cosine');
    case 4; set(handles.text_param2x,'String','Hamming');
    case 5; set(handles.text_param2x,'String','Hann');
    case 6; set(handles.text_param2x,'String','Bez filtru');
end
set(handles.text_param3x,'String',num2str(pocetprojekci));
set(handles.text_param4x,'String',num2str(pocetsektoru));
if rychlostzasunu~=0
    set(handles.text_param5x,'String',['Autom., zsun, ' num2str(rychlostzasunu) ' px / s']);
else
    set(handles.text_param5x,'String','Manuln');
end
set(handles.text_param6x,'String',[num2str(expozice) ' s']);
set(handles.text_param7x,'String',[num2str(fr_prezentace) ' obr / s']);

% Nastaven rolovac nabdky na posledn situaci (kdy dolo ke zmn
% charakteru rekonstrukce)
b=length(poradovecislo);
pomcell=cell(1);
for i=2:b;
    pomcell{i-1}=[num2str(poradovecislo(i)-pocetsektoru) '. snmek a ' num2str(poradovecislo(i)) '. snmek'];
end    
set(handles.popup_situace,'Value',b-1);
set(handles.popup_situace,'String',pomcell);

% Uloen sel snmk a snmk samotnch (tkajcch se analyzovan
% situace)
cislo_fluoro=poradovecislo(end)-pocetsektoru;
cislo_skia=poradovecislo(end);
obraz_fluoro=film{cislo_fluoro};
obraz_skia=film{cislo_skia};

% Zobrazen snmku s fluoroskopickou rekonstrukc v. popisku
axes(handles.horni);
image(obraz_fluoro)
colormap(map01)
axis off
set(handles.text_horni1,'String',[num2str(cislo_fluoro) '. snmek']);

% Zobrazen snmku s fluorografickou rekonstrukc v. popisku
axes(handles.dolni);
image(obraz_skia)
colormap(map01)
axis off
set(handles.text_dolni1,'String',[num2str(cislo_skia) '. snmek']);

% Vpoet rozdlu obraz
obraz_rozdil1=obraz_skia-obraz_fluoro;
obraz_rozdil2=obraz_fluoro-obraz_skia;

% Zobrazen rozdlu obraz v. popisku
axes(handles.vysledek1)
imshow(obraz_rozdil1);
colormap(map01)
axis off
set(handles.text_vysledek1,'String',[num2str(cislo_fluoro) '. snmek odeten od ' num2str(cislo_skia) '. snmku'])

% Zobrazen rozdlu obraz v. popisku
axes(handles.vysledek2)
imshow(obraz_rozdil2);
colormap(map01)
axis off
set(handles.text_vysledek2,'String',[num2str(cislo_skia) '. snmek odeten od ' num2str(cislo_fluoro) '. snmku'])

% Vpoet korelanho koeficientu
set(handles.text_vysledek,'String',['Korelace ' num2str(cislo_fluoro) '. snmku a ' num2str(cislo_skia) '. snmku : ' num2str(corr2(obraz_fluoro,obraz_skia))]);

% --- Outputs from this function are returned to the command line.
function varargout = analyza_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popup_situace.
function popup_situace_Callback(hObject, eventdata, handles)
% hObject    handle to popup_situace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popup_situace contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popup_situace

% Uivatel vybere situaci (kdy dolo ke zmn charakteru rekonstrukce) k
% analze

global obraz_fluoro obraz_skia poradovecislo pocetsektoru film map01 obraz_rozdil1 obraz_rozdil2

% Uloen sel snmk a snmk samotnch (vztahujcch se ke zvolen
% situaci)
cislo_fluoro=poradovecislo(get(handles.popup_situace,'Value')+1)-pocetsektoru;
cislo_skia=poradovecislo(get(handles.popup_situace,'Value')+1);
obraz_fluoro=film{cislo_fluoro};
obraz_skia=film{cislo_skia};

% Zobrazen snmku s fluoroskopickou rekonstrukc v. popisku
axes(handles.horni);
image(obraz_fluoro);
colormap(map01);
axis off;
set(handles.text_horni1,'String',[num2str(cislo_fluoro) '. snmek']);

% Zobrazen snmku s fluorografickou rekonstrukc v. popisku
axes(handles.dolni);
image(obraz_skia)
colormap(map01)
axis off
set(handles.text_dolni1,'String',[num2str(cislo_skia) '. snmek']);

% Vpoet rozdlu obraz
obraz_rozdil1=obraz_skia-obraz_fluoro;
obraz_rozdil2=obraz_fluoro-obraz_skia;

% Zobrazen rozdlu obraz v. popisku
axes(handles.vysledek1)
imshow(obraz_rozdil1);
colormap(map01)
axis off
set(handles.text_vysledek1,'String',[num2str(cislo_fluoro) '. snmek odeten od ' num2str(cislo_skia) '. snmku'])

% Zobrazen rozdlu obraz v. popisku
axes(handles.vysledek2)
imshow(obraz_rozdil2);
colormap(map01)
axis off
set(handles.text_vysledek2,'String',[num2str(cislo_skia) '. snmek odeten od ' num2str(cislo_fluoro) '. snmku'])

% Vpoet korelanho koeficientu
set(handles.text_vysledek,'String',['Korelace ' num2str(cislo_fluoro) '. snmku a ' num2str(cislo_skia) '. snmku : ' num2str(corr2(obraz_fluoro,obraz_skia))]);

% --- Executes during object creation, after setting all properties.
function popup_situace_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popup_situace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_spektrum1.
function push_spektrum1_Callback(hObject, eventdata, handles)
% hObject    handle to figure2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Funkce vypot amplitudov spektrum rozdlu snmk a zobraz jej v.
% popisk

global cislo_fluoro cislo_skia obraz_rozdil1

figure(4)
D1 = fft2(obraz_rozdil1,129,129);
D2 = fftshift(D1);
image([-1 1],[-1 1],jas_standard(abs(D2)))
axis image
colormap(jet)
set(gcf,'Name',['Amplitudov spektrum rozdlu ' num2str(cislo_fluoro) '. snmku a ' num2str(cislo_skia) '. snmku ']);
title(['Amplitudov spektrum rozdlu ' num2str(cislo_fluoro) '. snmku a ' num2str(cislo_skia) '. snmku ']);
xlabel('f_x / f_n');
ylabel('f_y / f_n');

% --- Executes on button press in push_spektrum2.
function push_spektrum2_Callback(hObject, eventdata, handles)
% hObject    handle to push_spektrum2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Funkce vypot amplitudov spektrum rozdlu snmk a zobraz jej v.
% popisk

global cislo_fluoro cislo_skia obraz_rozdil2

figure(5)
D1 = fft2(obraz_rozdil2,129,129);
D2 = fftshift(D1);
image([-1 1],[-1 1],jas_standard(abs(D2)))
axis image
colormap(jet)
set(gcf,'Name',['Amplitudov spektrum rozdlu ' num2str(cislo_skia) '. snmku a ' num2str(cislo_fluoro) '. snmku ']);
title(['Amplitudov spektrum rozdlu ' num2str(cislo_skia) '. snmku a ' num2str(cislo_fluoro) '. snmku ']);
xlabel('f_x / f_n');
ylabel('f_y / f_n');


% --- Executes on button press in push_histogram1.
function push_histogram1_Callback(hObject, eventdata, handles)
% hObject    handle to push_histogram1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Funkce vypot histogram rozdlu snmk a zobraz jej v. popisk

global cislo_fluoro cislo_skia obraz_rozdil1

figure(6);
rozdil=double(obraz_rozdil1);
rada(1,:)=rozdil(:);
hist(rada,0:255);
set(gcf,'Name',['Histogram rozdlu ' num2str(cislo_fluoro) '. snmku a ' num2str(cislo_skia) '. snmku ']);
title(['Histogram rozdlu ' num2str(cislo_fluoro) '. snmku a ' num2str(cislo_skia) '. snmku ']);
xlabel('Hladina jasu');
ylabel('Poet pixel');


% --- Executes on button press in push_histogram2.
function push_histogram2_Callback(hObject, eventdata, handles)
% hObject    handle to push_histogram2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Funkce vypot histogram rozdlu snmk a zobraz jej v. popisk

global cislo_fluoro cislo_skia obraz_rozdil2

figure(7);
rozdil=double(obraz_rozdil2);
rada(1,:)=rozdil(:);
hist(rada,0:255);
set(gcf,'Name',['Histogram rozdlu ' num2str(cislo_skia) '. snmku a ' num2str(cislo_fluoro) '. snmku ']);
title(['Histogram rozdlu ' num2str(cislo_skia) '. snmku a ' num2str(cislo_fluoro) '. snmku ']);
xlabel('Hladina jasu');
ylabel('Poet pixel');


% --- Executes on button press in push_kontrast1.
function push_kontrast1_Callback(hObject, eventdata, handles)
% hObject    handle to push_kontrast1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Funkce umon uivateli upravit kontrast zobrazovanho rozdlu snmk

h=imcontrast(handles.vysledek1);
set(h,'WindowStyle','modal');
uiwait(h);

% --- Executes on button press in push_kontrast2.
function push_kontrast2_Callback(hObject, eventdata, handles)
% hObject    handle to push_kontrast2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Funkce umon uivateli upravit kontrast zobrazovanho rozdlu snmk

h=imcontrast(handles.vysledek2);
set(h,'WindowStyle','modal');
uiwait(h);


% --------------------------------------------------------------------
function ulozit_Callback(hObject, eventdata, handles)
% hObject    handle to ulozit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Vbr nzvu souboru k uloen
set(gcf,'PaperPositionMode','auto')
set(gcf,'InvertHardcopy','off')
[nazev,cesta]=uiputfile('*.png','Uloit okno');
if nazev~=0
print('-dpng','-r300','-loose',[cesta nazev])

% Extrakce nzvu souboru (odmazn ppony)
delka=length(nazev);
for i=delka:-1:1
    if nazev(i)=='.'
        nazev=nazev(1:i-1);
        break
    end
end

% Vytvoen textovho souboru
fid = fopen([cesta nazev '.txt'], 'wt');
fprintf(fid, ['Popis k uloenmu screenshotu ' nazev '.png\n',...
              '\n',...
              get(handles.text_param1,'String') ' ' get(handles.text_param1x,'String') '\n',...
              get(handles.text_param2,'String') ' ' get(handles.text_param2x,'String') '\n',...
              get(handles.text_param3,'String') ' ' get(handles.text_param3x,'String') '\n',...
              get(handles.text_param4,'String') ' ' get(handles.text_param4x,'String') '\n',...
              get(handles.text_param5,'String') ' ' get(handles.text_param5x,'String') '\n',...
              get(handles.text_param6,'String') ' ' get(handles.text_param6x,'String') '\n',...
              get(handles.text_param7,'String') ' ' get(handles.text_param7x,'String') '\n',...
              '\n',...
              get(handles.text_vysledek,'String')]);
fclose(fid);

end

% --------------------------------------------------------------------
function zavrit_Callback(hObject, eventdata, handles)
% hObject    handle to zavrit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Zaven okna zkladn analzy

close
